diff --git a/python/psutil/examples/who.py b/python/psutil/examples/who.py
index b382bebfa3..1d8aa2854e 100755
--- a/python/psutil/examples/who.py
+++ b/python/psutil/examples/who.py
@@ -15,6 +15,7 @@ giampaolo       pts/8           2014-02-24 18:25  (:0)
 giampaolo       pts/9           2014-02-27 01:32  (:0)
 """
 
+from __future__ import print_function
 from datetime import datetime
 
 import psutil
@@ -23,11 +24,11 @@ import psutil
 def main():
     users = psutil.users()
     for user in users:
-        print("%-15s %-15s %s  (%s)" % (
+        print(("%-15s %-15s %s  (%s)" % (
             user.name,
             user.terminal or '-',
             datetime.fromtimestamp(user.started).strftime("%Y-%m-%d %H:%M"),
-            user.host))
+            user.host)))
 
 if __name__ == '__main__':
     main()
diff --git a/python/psutil/psutil/__init__.py b/python/psutil/psutil/__init__.py
index 1444425b8d..b39aa31bac 100644
--- a/python/psutil/psutil/__init__.py
+++ b/python/psutil/psutil/__init__.py
@@ -1,5 +1,4 @@
 #!/usr/bin/env python
-# -*- coding: utf-8 -*-
 
 # Copyright (c) 2009, Giampaolo Rodola'. All rights reserved.
 # Use of this source code is governed by a BSD-style license that can be
@@ -10,8 +9,8 @@ running processes and system utilization (CPU, memory, disks, network)
 in Python.
 """
 
-from __future__ import division
 
+from __future__ import print_function
 import collections
 import errno
 import functools
@@ -27,7 +26,7 @@ except ImportError:
 
 from . import _common
 from ._common import memoize
-from ._compat import callable, long
+from ._compat import callable, int
 from ._compat import PY3 as _PY3
 
 from ._common import (STATUS_RUNNING,  # NOQA
@@ -194,7 +193,7 @@ class Error(Exception):
         self.msg = msg
 
     def __repr__(self):
-        ret = "%s.%s %s" % (self.__class__.__module__,
+        ret = "{}.{} {}".format(self.__class__.__module__,
                             self.__class__.__name__, self.msg)
         return ret.strip()
 
@@ -213,7 +212,7 @@ class NoSuchProcess(Error):
         self.msg = msg
         if msg is None:
             if name:
-                details = "(pid=%s, name=%s)" % (self.pid, repr(self.name))
+                details = "(pid={}, name={})".format(self.pid, repr(self.name))
             else:
                 details = "(pid=%s)" % self.pid
             self.msg = "process no longer exists " + details
@@ -235,10 +234,10 @@ class ZombieProcess(NoSuchProcess):
         self.msg = msg
         if msg is None:
             if name and ppid:
-                details = "(pid=%s, name=%s, ppid=%s)" % (
+                details = "(pid={}, name={}, ppid={})".format(
                     self.pid, repr(self.name), self.ppid)
             elif name:
-                details = "(pid=%s, name=%s)" % (self.pid, repr(self.name))
+                details = "(pid={}, name={})".format(self.pid, repr(self.name))
             else:
                 details = "(pid=%s)" % self.pid
             self.msg = "process still exists but it's a zombie " + details
@@ -254,7 +253,7 @@ class AccessDenied(Error):
         self.msg = msg
         if msg is None:
             if (pid is not None) and (name is not None):
-                self.msg = "(pid=%s, name=%s)" % (pid, repr(name))
+                self.msg = "(pid={}, name={})".format(pid, repr(name))
             elif (pid is not None):
                 self.msg = "(pid=%s)" % self.pid
             else:
@@ -272,7 +271,7 @@ class TimeoutExpired(Error):
         self.pid = pid
         self.name = name
         if (pid is not None) and (name is not None):
-            self.msg += " (pid=%s, name=%s)" % (pid, repr(name))
+            self.msg += " (pid={}, name={})".format(pid, repr(name))
         elif (pid is not None):
             self.msg += " (pid=%s)" % self.pid
 
@@ -301,7 +300,7 @@ def _assert_pid_not_reused(fun):
     return wrapper
 
 
-class Process(object):
+class Process:
     """Represents an OS process with the given PID.
     If PID is omitted current process PID (os.getpid()) is used.
     Raise NoSuchProcess if PID does not exist.
@@ -341,7 +340,7 @@ class Process(object):
         if pid is None:
             pid = os.getpid()
         else:
-            if not _PY3 and not isinstance(pid, (int, long)):
+            if not _PY3 and not isinstance(pid, int):
                 raise TypeError('pid must be an integer (got %r)' % pid)
             if pid < 0:
                 raise ValueError('pid must be a positive integer (got %s)'
@@ -395,12 +394,12 @@ class Process(object):
         except AccessDenied:
             details = "(pid=%s)" % (self.pid)
         else:
-            details = "(pid=%s, name=%s)" % (pid, name)
-        return "%s.%s%s" % (self.__class__.__module__,
+            details = "(pid={}, name={})".format(pid, name)
+        return "{}.{}{}".format(self.__class__.__module__,
                             self.__class__.__name__, details)
 
     def __repr__(self):
-        return "<%s at %s>" % (self.__str__(), id(self))
+        return "<{} at {}>".format(self.__str__(), id(self))
 
     def __eq__(self, other):
         # Test for equality with another Process object based
@@ -432,9 +431,9 @@ class Process(object):
         AccessDenied or ZombieProcess exception is raised when
         retrieving that particular process information.
         """
-        excluded_names = set(
-            ['send_signal', 'suspend', 'resume', 'terminate', 'kill', 'wait',
-             'is_running', 'as_dict', 'parent', 'children', 'rlimit'])
+        excluded_names = {
+            'send_signal', 'suspend', 'resume', 'terminate', 'kill', 'wait',
+             'is_running', 'as_dict', 'parent', 'children', 'rlimit'}
         retdict = dict()
         ls = set(attrs or [x for x in dir(self)])
         for name in ls:
@@ -972,7 +971,7 @@ class Process(object):
                 path = tupl[2]
                 nums = tupl[3:]
                 try:
-                    d[path] = map(lambda x, y: x + y, d[path], nums)
+                    d[path] = list(map(lambda x, y: x + y, d[path], nums))
                 except KeyError:
                     d[path] = nums
             nt = _psplatform.pmmap_grouped
@@ -1165,7 +1164,7 @@ class Popen(Process):
     def wait(self, timeout=None):
         if self.__subproc.returncode is not None:
             return self.__subproc.returncode
-        ret = super(Popen, self).wait(timeout)
+        ret = super().wait(timeout)
         self.__subproc.returncode = ret
         return ret
 
@@ -1678,7 +1677,7 @@ def disk_io_counters(perdisk=False):
             rawdict[disk] = _common.sdiskio(*fields)
         return rawdict
     else:
-        return _common.sdiskio(*[sum(x) for x in zip(*rawdict.values())])
+        return _common.sdiskio(*[sum(x) for x in zip(*list(rawdict.values()))])
 
 
 # =====================================================================
@@ -1713,7 +1712,7 @@ def net_io_counters(pernic=False):
             rawdict[nic] = _common.snetio(*fields)
         return rawdict
     else:
-        return _common.snetio(*[sum(x) for x in zip(*rawdict.values())])
+        return _common.snetio(*[sum(x) for x in zip(*list(rawdict.values()))])
 
 
 def net_connections(kind='inet'):
@@ -1836,8 +1835,8 @@ def test():
     if _POSIX:
         attrs.append('uids')
         attrs.append('terminal')
-    print(templ % ("USER", "PID", "%CPU", "%MEM", "VSZ", "RSS", "TTY",
-                   "START", "TIME", "COMMAND"))
+    print((templ % ("USER", "PID", "%CPU", "%MEM", "VSZ", "RSS", "TTY",
+                   "START", "TIME", "COMMAND")))
     for p in process_iter():
         try:
             pinfo = p.as_dict(attrs, ad_value='')
@@ -1866,7 +1865,7 @@ def test():
                 int(pinfo['memory_info'].rss / 1024) or '?'
             memp = pinfo['memory_percent'] and \
                 round(pinfo['memory_percent'], 1) or '?'
-            print(templ % (
+            print((templ % (
                 user[:10],
                 pinfo['pid'],
                 pinfo['cpu_percent'],
@@ -1876,12 +1875,9 @@ def test():
                 pinfo.get('terminal', '') or '?',
                 ctime,
                 cputime,
-                pinfo['name'].strip() or '?'))
+                pinfo['name'].strip() or '?')))
 
 
 del memoize, division
-if sys.version_info < (3, 0):
-    del num
-
 if __name__ == "__main__":
     test()
diff --git a/python/psutil/psutil/_common.py b/python/psutil/psutil/_common.py
index e9acf595d7..b338a0ba27 100644
--- a/python/psutil/psutil/_common.py
+++ b/python/psutil/psutil/_common.py
@@ -6,7 +6,6 @@
 
 """Common objects shared by all _ps* modules."""
 
-from __future__ import division
 import errno
 import functools
 import os
diff --git a/python/psutil/psutil/_compat.py b/python/psutil/psutil/_compat.py
index 38744a84ae..f7326834ce 100644
--- a/python/psutil/psutil/_compat.py
+++ b/python/psutil/psutil/_compat.py
@@ -17,17 +17,17 @@ PY3 = sys.version_info[0] == 3
 if PY3:
     long = int
     xrange = range
-    unicode = str
+    str = str
 
     def u(s):
         return s
 else:
-    long = long
+    long = int
     xrange = xrange
-    unicode = unicode
+    str = str
 
     def u(s):
-        return unicode(s, "unicode_escape")
+        return str(s, "unicode_escape")
 
 
 # removed in 3.0, reintroduced in 3.2
@@ -67,7 +67,7 @@ except ImportError:
 
     def _make_key(args, kwds, typed,
                   kwd_mark=(object(), ),
-                  fasttypes=set((int, str, frozenset, type(None))),
+                  fasttypes={int, str, frozenset, type(None)},
                   sorted=sorted, tuple=tuple, type=type, len=len):
         key = args
         if kwds:
diff --git a/python/psutil/psutil/_psbsd.py b/python/psutil/psutil/_psbsd.py
index db54a02e13..f2d3a4c6b7 100644
--- a/python/psutil/psutil/_psbsd.py
+++ b/python/psutil/psutil/_psbsd.py
@@ -84,7 +84,7 @@ def virtual_memory():
 
 def swap_memory():
     """System swap memory as (total, used, free, sin, sout) namedtuple."""
-    total, used, free, sin, sout = [x * PAGESIZE for x in cext.swap_mem()]
+    total, used, free, sin, sout = (x * PAGESIZE for x in cext.swap_mem())
     percent = usage_percent(used, total, _round=1)
     return _common.sswap(total, used, free, percent, sin, sout)
 
@@ -216,7 +216,7 @@ def net_connections(kind):
 
 def net_if_stats():
     """Get NIC stats (isup, duplex, speed, mtu)."""
-    names = net_io_counters().keys()
+    names = list(net_io_counters().keys())
     ret = {}
     for name in names:
         isup, duplex, speed, mtu = cext_posix.net_if_stats(name)
@@ -258,7 +258,7 @@ def wrap_exceptions(fun):
     return wrapper
 
 
-class Process(object):
+class Process:
     """Wrapper class around underlying C implementation."""
 
     __slots__ = ["pid", "_name", "_ppid"]
diff --git a/python/psutil/psutil/_pslinux.py b/python/psutil/psutil/_pslinux.py
index 7eb25f519c..f956ef44db 100644
--- a/python/psutil/psutil/_pslinux.py
+++ b/python/psutil/psutil/_pslinux.py
@@ -6,7 +6,6 @@
 
 """Linux platform implementation."""
 
-from __future__ import division
 
 import base64
 import errno
@@ -25,7 +24,8 @@ from . import _psutil_linux as cext
 from . import _psutil_posix as cext_posix
 from ._common import isfile_strict, usage_percent
 from ._common import NIC_DUPLEX_FULL, NIC_DUPLEX_HALF, NIC_DUPLEX_UNKNOWN
-from ._compat import PY3, long
+from ._compat import PY3, int
+import six
 
 if sys.version_info >= (3, 4):
     import enum
@@ -262,8 +262,8 @@ def cpu_count_logical():
         # https://github.com/giampaolo/psutil/issues/200
         # try to parse /proc/stat as a last resort
         if num == 0:
-            search = re.compile('cpu\d')
-            with open('/proc/stat', 'rt') as f:
+            search = re.compile(r'cpu\d')
+            with open('/proc/stat') as f:
                 for line in f:
                     line = line.split(' ')[0]
                     if search.match(line):
@@ -382,7 +382,7 @@ class Connections:
         inodes = defaultdict(list)
         for fd in os.listdir("/proc/%s/fd" % pid):
             try:
-                inode = os.readlink("/proc/%s/fd/%s" % (pid, fd))
+                inode = os.readlink("/proc/{}/fd/{}".format(pid, fd))
             except OSError as err:
                 # ENOENT == file which is gone in the meantime;
                 # os.stat('/proc/%s' % self.pid) will be done later
@@ -471,7 +471,7 @@ class Connections:
         if file.endswith('6') and not os.path.exists(file):
             # IPv6 not supported
             return
-        with open(file, 'rt') as f:
+        with open(file) as f:
             f.readline()  # skip the first line
             for line in f:
                 try:
@@ -479,7 +479,7 @@ class Connections:
                         line.split()[:10]
                 except ValueError:
                     raise RuntimeError(
-                        "error while parsing %s; malformed line %r" % (
+                        "error while parsing {}; malformed line {!r}".format(
                             file, line))
                 if inode in inodes:
                     # # We assume inet sockets are unique, so we error
@@ -504,7 +504,7 @@ class Connections:
 
     def process_unix(self, file, family, inodes, filter_pid=None):
         """Parse /proc/net/unix files."""
-        with open(file, 'rt') as f:
+        with open(file) as f:
             f.readline()  # skip the first line
             for line in f:
                 tokens = line.split()
@@ -512,7 +512,7 @@ class Connections:
                     _, _, _, _, type_, _, inode = tokens[0:7]
                 except ValueError:
                     raise RuntimeError(
-                        "error while parsing %s; malformed line %r" % (
+                        "error while parsing {}; malformed line {!r}".format(
                             file, line))
                 if inode in inodes:
                     # With UNIX sockets we can have a single inode
@@ -575,7 +575,7 @@ def net_io_counters():
     """Return network I/O statistics for every network interface
     installed on the system as a dict of raw tuples.
     """
-    with open("/proc/net/dev", "rt") as f:
+    with open("/proc/net/dev") as f:
         lines = f.readlines()
     retdict = {}
     for line in lines[2:]:
@@ -601,7 +601,7 @@ def net_if_stats():
     duplex_map = {cext.DUPLEX_FULL: NIC_DUPLEX_FULL,
                   cext.DUPLEX_HALF: NIC_DUPLEX_HALF,
                   cext.DUPLEX_UNKNOWN: NIC_DUPLEX_UNKNOWN}
-    names = net_io_counters().keys()
+    names = list(net_io_counters().keys())
     ret = {}
     for name in names:
         isup, duplex, speed, mtu = cext.net_if_stats(name)
@@ -626,7 +626,7 @@ def disk_io_counters():
 
     # determine partitions we want to look for
     partitions = []
-    with open("/proc/partitions", "rt") as f:
+    with open("/proc/partitions") as f:
         lines = f.readlines()[2:]
     for line in reversed(lines):
         _, _, _, name = line.split()
@@ -643,7 +643,7 @@ def disk_io_counters():
                 partitions.append(name)
     #
     retdict = {}
-    with open("/proc/diskstats", "rt") as f:
+    with open("/proc/diskstats") as f:
         lines = f.readlines()
     for line in lines:
         # http://www.mjmwired.net/kernel/Documentation/iostats.txt
@@ -669,7 +669,7 @@ def disk_io_counters():
 def disk_partitions(all=False):
     """Return mounted disk partitions as a list of namedtuples"""
     fstypes = set()
-    with open("/proc/filesystems", "r") as f:
+    with open("/proc/filesystems") as f:
         for line in f:
             line = line.strip()
             if not line.startswith("nodev"):
@@ -707,7 +707,7 @@ def wrap_exceptions(fun):
     def wrapper(self, *args, **kwargs):
         try:
             return fun(self, *args, **kwargs)
-        except EnvironmentError as err:
+        except OSError as err:
             # support for private module import
             if NoSuchProcess is None or AccessDenied is None:
                 raise
@@ -736,7 +736,7 @@ def wrap_exceptions_w_zombie(fun):
     return wrapper
 
 
-class Process(object):
+class Process:
     """Linux process implementation."""
 
     __slots__ = ["pid", "_name", "_ppid"]
@@ -887,7 +887,7 @@ class Process(object):
         #  ============================================================
         with open("/proc/%s/statm" % self.pid, "rb") as f:
             vms, rss, shared, text, lib, data, dirty = \
-                [int(x) * PAGESIZE for x in f.readline().split()[:7]]
+                (int(x) * PAGESIZE for x in f.readline().split()[:7])
         return pextmem(rss, vms, shared, text, lib, data, dirty)
 
     if os.path.exists('/proc/%s/smaps' % os.getpid()):
@@ -898,7 +898,7 @@ class Process(object):
             Fields are explained in 'man proc'; here is an updated (Apr 2012)
             version: http://goo.gl/fmebo
             """
-            with open("/proc/%s/smaps" % self.pid, "rt") as f:
+            with open("/proc/%s/smaps" % self.pid) as f:
                 first_line = f.readline()
                 current_block = [first_line]
 
@@ -996,11 +996,11 @@ class Process(object):
         retlist = []
         hit_enoent = False
         for thread_id in thread_ids:
-            fname = "/proc/%s/task/%s/stat" % (self.pid, thread_id)
+            fname = "/proc/{}/task/{}/stat".format(self.pid, thread_id)
             try:
                 with open(fname, 'rb') as f:
                     st = f.read().strip()
-            except IOError as err:
+            except OSError as err:
                 if err.errno == errno.ENOENT:
                     # no such file or directory; it means thread
                     # disappeared on us
@@ -1062,7 +1062,7 @@ class Process(object):
         @wrap_exceptions
         def ionice_set(self, ioclass, value):
             if value is not None:
-                if not PY3 and not isinstance(value, (int, long)):
+                if not PY3 and not isinstance(value, int):
                     msg = "value argument is not an integer (gor %r)" % value
                     raise TypeError(msg)
                 if not 0 <= value <= 8:
@@ -1138,7 +1138,7 @@ class Process(object):
         files = os.listdir("/proc/%s/fd" % self.pid)
         hit_enoent = False
         for fd in files:
-            file = "/proc/%s/fd/%s" % (self.pid, fd)
+            file = "/proc/{}/fd/{}".format(self.pid, fd)
             try:
                 file = os.readlink(file)
             except OSError as err:
diff --git a/python/psutil/psutil/_psosx.py b/python/psutil/psutil/_psosx.py
index 41875fe404..ef8b8f823e 100644
--- a/python/psutil/psutil/_psosx.py
+++ b/python/psutil/psutil/_psosx.py
@@ -170,7 +170,7 @@ def net_connections(kind='inet'):
 
 def net_if_stats():
     """Get NIC stats (isup, duplex, speed, mtu)."""
-    names = net_io_counters().keys()
+    names = list(net_io_counters().keys())
     ret = {}
     for name in names:
         isup, duplex, speed, mtu = cext_posix.net_if_stats(name)
@@ -212,7 +212,7 @@ def wrap_exceptions(fun):
     return wrapper
 
 
-class Process(object):
+class Process:
     """Wrapper class around underlying C implementation."""
 
     __slots__ = ["pid", "_name", "_ppid"]
diff --git a/python/psutil/psutil/_psposix.py b/python/psutil/psutil/_psposix.py
index 5bb16a386d..69bcf63595 100644
--- a/python/psutil/psutil/_psposix.py
+++ b/python/psutil/psutil/_psposix.py
@@ -13,7 +13,7 @@ import sys
 import time
 
 from ._common import sdiskusage, usage_percent, memoize
-from ._compat import PY3, unicode
+from ._compat import PY3, str
 
 
 class TimeoutExpired(Exception):
@@ -120,7 +120,7 @@ def disk_usage(path):
     try:
         st = os.statvfs(path)
     except UnicodeEncodeError:
-        if not PY3 and isinstance(path, unicode):
+        if not PY3 and isinstance(path, str):
             # this is a bug with os.statvfs() and unicode on
             # Python 2, see:
             # - https://github.com/giampaolo/psutil/issues/416
diff --git a/python/psutil/psutil/_pssunos.py b/python/psutil/psutil/_pssunos.py
index bc35a718c3..046ede4ca3 100644
--- a/python/psutil/psutil/_pssunos.py
+++ b/python/psutil/psutil/_pssunos.py
@@ -252,7 +252,7 @@ def wrap_exceptions(fun):
     def wrapper(self, *args, **kwargs):
         try:
             return fun(self, *args, **kwargs)
-        except EnvironmentError as err:
+        except OSError as err:
             # support for private module import
             if (NoSuchProcess is None or AccessDenied is None or
                     ZombieProcess is None):
@@ -271,7 +271,7 @@ def wrap_exceptions(fun):
     return wrapper
 
 
-class Process(object):
+class Process:
     """Wrapper class around underlying C implementation."""
 
     __slots__ = ["pid", "_name", "_ppid"]
@@ -317,7 +317,7 @@ class Process(object):
         # fine.
         try:
             return cext_posix.getpriority(self.pid)
-        except EnvironmentError as err:
+        except OSError as err:
             # 48 is 'operation not supported' but errno does not expose
             # it. It occurs for low system pids.
             if err.errno in (errno.ENOENT, errno.ESRCH, 48):
@@ -411,7 +411,7 @@ class Process(object):
             try:
                 utime, stime = cext.query_process_thread(
                     self.pid, tid)
-            except EnvironmentError as err:
+            except OSError as err:
                 # ENOENT == thread gone in meantime
                 if err.errno == errno.ENOENT:
                     hit_enoent = True
@@ -458,14 +458,14 @@ class Process(object):
                              stderr=subprocess.PIPE)
         stdout, stderr = p.communicate()
         if PY3:
-            stdout, stderr = [x.decode(sys.stdout.encoding)
-                              for x in (stdout, stderr)]
+            stdout, stderr = (x.decode(sys.stdout.encoding)
+                              for x in (stdout, stderr))
         if p.returncode != 0:
             if 'permission denied' in stderr.lower():
                 raise AccessDenied(self.pid, self._name)
             if 'no such process' in stderr.lower():
                 raise NoSuchProcess(self.pid, self._name)
-            raise RuntimeError("%r command error\n%s" % (cmd, stderr))
+            raise RuntimeError("{!r} command error\n{}".format(cmd, stderr))
 
         lines = stdout.split('\n')[2:]
         for i, line in enumerate(lines):
@@ -504,7 +504,7 @@ class Process(object):
     @wrap_exceptions
     def memory_maps(self):
         def toaddr(start, end):
-            return '%s-%s' % (hex(start)[2:].strip('L'),
+            return '{}-{}'.format(hex(start)[2:].strip('L'),
                               hex(end)[2:].strip('L'))
 
         retlist = []
@@ -515,7 +515,7 @@ class Process(object):
             addr = toaddr(addr, addrsize)
             if not name.startswith('['):
                 try:
-                    name = os.readlink('/proc/%s/path/%s' % (self.pid, name))
+                    name = os.readlink('/proc/{}/path/{}'.format(self.pid, name))
                 except OSError as err:
                     if err.errno == errno.ENOENT:
                         # sometimes the link may not be resolved by
@@ -524,7 +524,7 @@ class Process(object):
                         # unresolved link path.
                         # This seems an incosistency with /proc similar
                         # to: http://goo.gl/55XgO
-                        name = '/proc/%s/path/%s' % (self.pid, name)
+                        name = '/proc/{}/path/{}'.format(self.pid, name)
                         hit_enoent = True
                     else:
                         raise
diff --git a/python/psutil/psutil/_pswindows.py b/python/psutil/psutil/_pswindows.py
index 2d8babb19c..c609d24441 100644
--- a/python/psutil/psutil/_pswindows.py
+++ b/python/psutil/psutil/_pswindows.py
@@ -16,7 +16,7 @@ from . import _common
 from . import _psutil_windows as cext
 from ._common import conn_tmap, usage_percent, isfile_strict
 from ._common import sockfam_to_enum, socktype_to_enum
-from ._compat import PY3, xrange, lru_cache, long
+from ._compat import PY3, xrange, lru_cache, int
 from ._psutil_windows import (ABOVE_NORMAL_PRIORITY_CLASS,
                               BELOW_NORMAL_PRIORITY_CLASS,
                               HIGH_PRIORITY_CLASS,
@@ -143,7 +143,7 @@ def disk_usage(path):
     """Return disk usage associated with path."""
     try:
         total, free = cext.disk_usage(path)
-    except WindowsError:
+    except OSError:
         if not os.path.exists(path):
             msg = "No such file or directory: '%s'" % path
             raise OSError(errno.ENOENT, msg)
@@ -262,7 +262,7 @@ def wrap_exceptions(fun):
     return wrapper
 
 
-class Process(object):
+class Process:
     """Wrapper class around underlying C implementation."""
 
     __slots__ = ["pid", "_name", "_ppid"]
@@ -503,7 +503,7 @@ class Process(object):
     @wrap_exceptions
     def cpu_affinity_get(self):
         def from_bitmask(x):
-            return [i for i in xrange(64) if (1 << i) & x]
+            return [i for i in range(64) if (1 << i) & x]
         bitmask = cext.proc_cpu_affinity_get(self.pid)
         return from_bitmask(bitmask)
 
@@ -523,7 +523,7 @@ class Process(object):
         allcpus = list(range(len(per_cpu_times())))
         for cpu in value:
             if cpu not in allcpus:
-                if not isinstance(cpu, (int, long)):
+                if not isinstance(cpu, int):
                     raise TypeError(
                         "invalid CPU %r; an integer is required" % cpu)
                 else:
diff --git a/python/psutil/setup.py b/python/psutil/setup.py
index 4c42548ef3..1643f48cac 100644
--- a/python/psutil/setup.py
+++ b/python/psutil/setup.py
@@ -22,7 +22,7 @@ HERE = os.path.abspath(os.path.dirname(__file__))
 
 def get_version():
     INIT = os.path.join(HERE, 'psutil/__init__.py')
-    with open(INIT, 'r') as f:
+    with open(INIT) as f:
         for line in f:
             if line.startswith('__version__'):
                 ret = eval(line.strip().split(' = ')[1])
@@ -36,7 +36,7 @@ def get_version():
 
 def get_description():
     README = os.path.join(HERE, 'README.rst')
-    with open(README, 'r') as f:
+    with open(README) as f:
         return f.read()
 
 
diff --git a/python/psutil/test/_bsd.py b/python/psutil/test/_bsd.py
index e4a3225d20..51cf8accd3 100644
--- a/python/psutil/test/_bsd.py
+++ b/python/psutil/test/_bsd.py
@@ -103,9 +103,9 @@ class BSDSpecificTestCase(unittest.TestCase):
             self.assertEqual(usage.total, total)
             # 10 MB tollerance
             if abs(usage.free - free) > 10 * 1024 * 1024:
-                self.fail("psutil=%s, df=%s" % (usage.free, free))
+                self.fail("psutil={}, df={}".format(usage.free, free))
             if abs(usage.used - used) > 10 * 1024 * 1024:
-                self.fail("psutil=%s, df=%s" % (usage.used, used))
+                self.fail("psutil={}, df={}".format(usage.used, used))
 
     @retry_before_failing()
     def test_memory_maps(self):
@@ -117,7 +117,7 @@ class BSDSpecificTestCase(unittest.TestCase):
             fields = line.split()
             _, start, stop, perms, res = fields[:5]
             map = maps.pop()
-            self.assertEqual("%s-%s" % (start, stop), map.addr)
+            self.assertEqual("{}-{}".format(start, stop), map.addr)
             self.assertEqual(int(res), map.rss)
             if not map.path.startswith('['):
                 self.assertEqual(fields[10], map.path)
@@ -243,7 +243,7 @@ class BSDSpecificTestCase(unittest.TestCase):
 
 def main():
     test_suite = unittest.TestSuite()
-    test_suite.addTest(unittest.makeSuite(BSDSpecificTestCase))
+    test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(BSDSpecificTestCase))
     result = unittest.TextTestRunner(verbosity=2).run(test_suite)
     return result.wasSuccessful()
 
diff --git a/python/psutil/test/_linux.py b/python/psutil/test/_linux.py
index c1927ea8b2..d82313255a 100644
--- a/python/psutil/test/_linux.py
+++ b/python/psutil/test/_linux.py
@@ -6,7 +6,6 @@
 
 """Linux specific tests.  These are implicitly run by test_psutil.py."""
 
-from __future__ import division
 import contextlib
 import errno
 import fcntl
@@ -24,7 +23,7 @@ import warnings
 try:
     from unittest import mock  # py3
 except ImportError:
-    import mock  # requires "pip install mock"
+    from unittest import mock
 
 from test_psutil import POSIX, TOLERANCE, TRAVIS, LINUX
 from test_psutil import (skip_on_not_implemented, sh, get_test_subprocess,
@@ -65,8 +64,8 @@ def get_mac_address(ifname):
             def ord(x):
                 return x
         else:
-            import __builtin__
-            ord = __builtin__.ord
+            import builtins
+            ord = builtins.ord
         return ''.join(['%02x:' % ord(char) for char in info[18:24]])[:-1]
 
 
@@ -98,9 +97,9 @@ class LinuxSpecificTestCase(unittest.TestCase):
             self.assertEqual(usage.total, total)
             # 10 MB tollerance
             if abs(usage.free - free) > 10 * 1024 * 1024:
-                self.fail("psutil=%s, df=%s" % (usage.free, free))
+                self.fail("psutil={}, df={}".format(usage.free, free))
             if abs(usage.used - used) > 10 * 1024 * 1024:
-                self.fail("psutil=%s, df=%s" % (usage.used, used))
+                self.fail("psutil={}, df={}".format(usage.used, used))
 
     def test_memory_maps(self):
         sproc = get_test_subprocess()
@@ -176,7 +175,7 @@ class LinuxSpecificTestCase(unittest.TestCase):
     @unittest.skipIf(TRAVIS, "unknown failure on travis")
     def test_cpu_times(self):
         fields = psutil.cpu_times()._fields
-        kernel_ver = re.findall('\d+\.\d+\.\d+', os.uname()[2])[0]
+        kernel_ver = re.findall(r'\d+\.\d+\.\d+', os.uname()[2])[0]
         kernel_ver_info = tuple(map(int, kernel_ver.split('.')))
         if kernel_ver_info >= (2, 6, 11):
             self.assertIn('steal', fields)
@@ -208,11 +207,11 @@ class LinuxSpecificTestCase(unittest.TestCase):
         found = 0
         for line in out.split('\n'):
             line = line.strip()
-            if re.search("^\d+:", line):
+            if re.search(r"^\d+:", line):
                 found += 1
                 name = line.split(':')[1].strip()
-                self.assertIn(name, nics.keys())
-        self.assertEqual(len(nics), found, msg="%s\n---\n%s" % (
+                self.assertIn(name, list(nics.keys()))
+        self.assertEqual(len(nics), found, msg="{}\n---\n{}".format(
             pprint.pformat(nics), out))
 
     @unittest.skipUnless(which("nproc"), "nproc utility not available")
@@ -404,7 +403,7 @@ class LinuxSpecificTestCase(unittest.TestCase):
 
     def test_disk_partitions_mocked(self):
         # Test that ZFS partitions are returned.
-        with open("/proc/filesystems", "r") as f:
+        with open("/proc/filesystems") as f:
             data = f.read()
         if 'zfs' in data:
             for part in psutil.disk_partitions():
@@ -464,7 +463,7 @@ class LinuxSpecificTestCase(unittest.TestCase):
 
 def main():
     test_suite = unittest.TestSuite()
-    test_suite.addTest(unittest.makeSuite(LinuxSpecificTestCase))
+    test_suite.addTest(unittest.defaultTestLoader.loadTestsFromTestCase(LinuxSpecificTestCase))
     result = unittest.TextTestRunner(verbosity=2).run(test_suite)
     return result.wasSuccessful()
 
